/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_PERCENTIL                                                */
/* Tabela : PERCENTIL                                                         */
/* Criao:                                                                   */
/*                                                                            */
/* 02/02/2005 - Jonathan Abdon Silva                           	            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PERCENTIL'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_PERCENTIL
  GO


CREATE TRIGGER DTULTATU_PERCENTIL
ON PERCENTIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PERCENTIL', NULL, 'CDPERCENTIL='+CDPERCENTIL+';', GETDATE()FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PERCENTIL
      SET DTULTATUPERC = GETDATE()
      FROM INSERTED
      WHERE
         (PERCENTIL.CDPERCENTIL = INSERTED.CDPERCENTIL)
   END;
END;
GO



